<?php
/*
Plugin Name: Comments on Albums
Version: auto
Description: Activate comments on albums pages
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=512
Author: Mistic
Author URI: http://www.strangeplanet.fr
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $prefixeTable;

// +-----------------------------------------------------------------------+
//          Global variables
// +-----------------------------------------------------------------------+
define('COA_DIR' , basename(dirname(__FILE__)));
define('COA_PATH' , PHPWG_PLUGINS_PATH . COA_DIR . '/');
define('COA_TABLE' , $prefixeTable . 'comments_categories');
define('COA_ADMIN', get_root_url().'admin.php?page=plugin-' . COA_DIR);


// +-----------------------------------------------------------------------+
//          Triggers
// +-----------------------------------------------------------------------+
add_event_handler('loc_end_index', 'COA_albums');
add_event_handler('loc_after_page_header', 'COA_comments_page');
add_event_handler('loc_begin_admin_page', 'COA_admin_intro');
add_event_handler('loc_end_admin', 'COA_admin_comments');
add_event_handler('get_admin_plugin_menu_links', 'COA_admin_menu');


// +-----------------------------------------------------------------------+
//          Functions
// +-----------------------------------------------------------------------+

function COA_albums() 
{
  global $template, $page, $conf, $pwg_loaded_plugins;
  
  if (
    $page['section'] == 'categories' AND isset($page['category']) AND 
    ( !isset($pwg_loaded_plugins['rv_tscroller']) OR count($page['navigation_bar']) == 0 )
  ) {   
    if (isset($pwg_loaded_plugins['bbcode_bar']) AND !isset($_GET['comment_to_edit'])) 
    {
      set_bbcode_bar();
      $template->set_prefilter('comments_on_albums', 'set_bbcode_bar_prefilter'); 
      if (isset($pwg_loaded_plugins['SmiliesSupport']))
      {
        $template->set_prefilter('comments_on_albums', 'set_smiliessupport_prefilter');
      }
    }
    else if (isset($pwg_loaded_plugins['SmiliesSupport']) AND !isset($_GET['comment_to_edit'])) 
    {
      set_smiliessupport();
      $template->set_prefilter('comments_on_albums', 'set_smiliessupport_prefilter');
    }
    
    include(COA_PATH . 'include/coa_albums.php');
  }
}

function COA_comments_page() 
{
  global $template, $page, $conf, $user;
  
  if (isset($page['body_id']) AND $page['body_id'] == 'theCommentsPage') 
  {
    include(COA_PATH . 'include/coa_comments_page.php');
  }
}

function COA_admin_intro() 
{
  global $page;
  
  if ($page['page'] == 'intro') 
  {  
    include(COA_PATH . 'include/coa_admin_intro.php');
  } 
}

function COA_admin_comments() 
{
  global $page;
  
  if ($page['page'] == 'comments') 
  {  
    include(COA_PATH . 'include/coa_admin_comments.php');
  }
}

function COA_admin_menu($menu) 
{
  array_push($menu, array(
    'NAME' => 'Comments on Albums',
    'URL' => COA_ADMIN
  ));
  return $menu;
}

?>